#include "SimpleSynthNode.h"
#include "SimpleSynthAddOn.h"

extern "C" _EXPORT 
BMediaAddOn* 
make_media_addon( image_id image )
{
	return new SimpleSynthAddOn( image );
}

SimpleSynthAddOn::
SimpleSynthAddOn( image_id image )
:	BMediaAddOn( image )
{
}

SimpleSynthAddOn::
~SimpleSynthAddOn()
{
}

status_t 
SimpleSynthAddOn::
InitCheck( const char** out_failure_text )
{
	return B_OK;
}
	
int32 
SimpleSynthAddOn::
CountFlavors()
{
	return 1;
}

status_t 
SimpleSynthAddOn::
GetFlavorAt( 
		int32 flavorNum, 
		const flavor_info** outInfo)
{
	if( flavorNum != 0 )
		return B_ERROR;
	
	flavor_info* info = new flavor_info;
	info->internal_id = flavorNum;
	info->name = "SimpleSynth";
	info->info = "This is SimpleSynth node";

	info->kinds = B_BUFFER_PRODUCER;
	info->flavor_flags = 0;
	info->possible_count = 0;
		
	info->in_format_count = 0;
	info->in_formats = 0;
	
	info->out_format_count = 1;
	media_format* format = new media_format;
	format->type = B_MEDIA_RAW_AUDIO;
	format->u.raw_audio = media_raw_audio_format::wildcard;
	info->out_formats = format;
	
	*outInfo = info;

	return B_OK;
}

BMediaNode* 
SimpleSynthAddOn::
InstantiateNodeFor(
		const flavor_info* info,
		BMessage* config,
		status_t* out_error)
{
	return new SimpleSynthNode(this);	
}

status_t 
SimpleSynthAddOn::
GetConfigurationFor(
		BMediaNode* your_node,
		BMessage* into_message)
{	
	return B_OK;
}

bool 
SimpleSynthAddOn::
WantsAutoStart()
{
	return false;
}

status_t
SimpleSynthAddOn::
AutoStart(
		int in_count,
		BMediaNode ** out_node,
		int32 * out_internal_id,
		bool * out_has_more)
{
	return B_OK;
}

